<template>
  <div class="row">
    <div class="col-md-12">
      <transition name="fade">
        <div v-if="categories">
          <alert-error :form="form" :message="$t('invalid_form')"></alert-error>
          <b-card :header="$t('create_ticket')" header-tag="header">
            <form
              @submit.prevent="createTicket"
              @keydown="form.onKeydown($event)"
            >
              <b-card-text>
                <b-form-group
                  id="name-group"
                  :label="$t('ticket_name')"
                  label-for="name"
                >
                  <b-form-input
                    id="name"
                    v-model="form.name"
                    type="text"
                    required
                    :placeholder="$t('ticket_name')"
                    :class="{ 'is-invalid': form.errors.has('name') }"
                  ></b-form-input>
                  <has-error :form="form" field="name" />
                </b-form-group>
                <b-form-group
                  id="category-group"
                  :label="$t('ticket_category')"
                  label-for="category"
                >
                  <b-form-select
                    v-model="form.category_id"
                    :options="categoryOptions"
                    :class="{ 'is-invalid': form.errors.has('category_id') }"
                  ></b-form-select>
                  <has-error :form="form" field="category_id" />
                </b-form-group>
                <transition name="page">
                  <b-form-group
                    id="order-group"
                    :label="$t('ticket_order_id')"
                    label-for="order"
                    v-if="
                      selectedCategory && selectedCategory.is_replace_category
                    "
                    :key="selectedCategory.id"
                  >
                    <b-form-input
                      id="order"
                      v-model="form.order_id"
                      type="text"
                      required
                      :placeholder="$t('ticket_order_id')"
                      :class="{ 'is-invalid': form.errors.has('order_id') }"
                    ></b-form-input>
                    <has-error :form="form" field="order_id" />
                  </b-form-group>
                </transition>
                <b-form-group
                  id="content-group"
                  :label="$t('ticket_content')"
                  label-for="content"
                >
                  <b-form-textarea
                    id="content"
                    v-model="form.content"
                    required
                    :placeholder="$t('ticket_content')"
                    :class="{ 'is-invalid': form.errors.has('content') }"
                    rows="10"
                    max-rows="15"
                  ></b-form-textarea>
                  <has-error :form="form" field="content" />
                </b-form-group>
              </b-card-text>
              <b-button type="submit" variant="info">{{
                $t("create_ticket")
              }}</b-button>
            </form>
          </b-card>
        </div>
      </transition>
    </div>
  </div>
</template>

<script>
import Form from "vform";
import { mapGetters } from "vuex";
import axios from "axios";

export default {
  scrollToTop: false,

  metaInfo() {
    return { title: this.$t("create_ticket") };
  },

  data: () => ({
    form: new Form({
      category_id: "",
      order_id: "",
      name: "",
      content: ""
    }),
    categories: null
  }),

  computed: {
    categoryOptions() {
      let options = [];
      this.categories.forEach(category => {
        options.push({ value: category.id, text: category.name });
      });
      return options;
    },
    selectedCategory() {
      if (!this.form.category_id) {
        return undefined;
      }
      return this.categories.find(category => {
        return category.id === this.form.category_id;
      });
    }
  },

  mounted() {
    this.getCategories();
  },

  methods: {
    async getCategories() {
      const { data } = await axios.get(route("shop.tickets.categories.index"));
      if (data) {
        this.categories = data;
      }
    },
    async createTicket() {
      const { data } = await this.form.post(route("shop.tickets.create"));
      if (data.id) {
        this.$router.push({ name: "panel.tickets" });
      } else {
      }
    }
  }
};
</script>
